Botan 2.13.0 Crypto and TLS for C++11

- Main Page
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions | List of all members
Botan::PasswordHashFamily Class Referenceabstract

`#include <pwdhash.h>`

Inheritance diagram for Botan::PasswordHashFamily:

## Public Member Functions
virtual std::unique_ptr< PasswordHash > | default_params () const =0
virtual std::unique_ptr< PasswordHash > | from_iterations (size_t iterations) const =0
virtual std::unique_ptr< PasswordHash > | from_params (size_t i1, size_t i2=0, size_t i3=0) const =0
virtual std::string | name () const =0
virtual std::unique_ptr< PasswordHash > | tune (size_t output_length, std::chrono::milliseconds msec, size_t max_memory_usage_mb=0) const =0
virtual | ~PasswordHashFamily ()=default

## Static Public Member Functions
static std::unique_ptr< PasswordHashFamily > | create (const std::string &algo_spec, const std::string &provider="")
static std::unique_ptr< PasswordHashFamily > | create_or_throw (const std::string &algo_spec, const std::string &provider="")
static std::vector< std::string > | providers (const std::string &algo_spec)

## Detailed Description

Definition at line 79 of file pwdhash.h.

## Constructor & Destructor Documentation

virtual Botan::PasswordHashFamily::~PasswordHashFamily | ( |  | ) |
| virtual default

## Member Function Documentation

std::unique_ptr< PasswordHashFamily > Botan::PasswordHashFamily::create | ( | const std::string & | algo_spec,
|  | const std::string & | provider = `""`
| ) |  |
| static

Create an instance based on a name If provider is empty then best available is chosen.

Parameters

  algo_spec | algorithm name
  provider | provider implementation to choose

Returns
  a null pointer if the algo/provider combination cannot be found

Definition at line 33 of file pwdhash.cpp.

References Botan::SCAN_Name::algo_name(), Botan::SCAN_Name::arg(), Botan::SCAN_Name::arg_count(), BOTAN_UNUSED, Botan::HashFunction::create(), Botan::MessageAuthenticationCode::create(), and hash.

Referenced by botan_pwdhash(), botan_pwdhash_timed(), and create_or_throw().

35 {
36 const SCAN_Name req(algo_spec);
37
38 #if defined(BOTAN_HAS_PBKDF2)
39 if(req.algo_name() == "PBKDF2")
40 {
41 // TODO OpenSSL
42
43 if(provider.empty() || provider == "base")
44 {
45 if(auto mac = MessageAuthenticationCode::create(req.arg(0)))
46 return std::unique_ptr<PasswordHashFamily>(new PBKDF2_Family(mac.release()));
47
48 if(auto mac = MessageAuthenticationCode::create("HMAC(" + req.arg(0) + ")"))
49 return std::unique_ptr<PasswordHashFamily>(new PBKDF2_Family(mac.release()));
50 }
51
52 return nullptr;
53 }
54 #endif
55
56 #if defined(BOTAN_HAS_SCRYPT)
57 if(req.algo_name() == "Scrypt")
58 {
59 return std::unique_ptr<PasswordHashFamily>(new Scrypt_Family);
60 }
61 #endif
62
63 #if defined(BOTAN_HAS_ARGON2)
64 if(req.algo_name() == "Argon2d")
65 {
66 return std::unique_ptr<PasswordHashFamily>(new Argon2_Family(0));
67 }
68 else if(req.algo_name() == "Argon2i")
69 {
70 return std::unique_ptr<PasswordHashFamily>(new Argon2_Family(1));
71 }
72 else if(req.algo_name() == "Argon2id")
73 {
74 return std::unique_ptr<PasswordHashFamily>(new Argon2_Family(2));
75 }
76 #endif
77
78 #if defined(BOTAN_HAS_PBKDF_BCRYPT)
79 if(req.algo_name() == "Bcrypt-PBKDF")
80 {
81 return std::unique_ptr<PasswordHashFamily>(new Bcrypt_PBKDF_Family);
82 }
83 #endif
84
85 #if defined(BOTAN_HAS_PGP_S2K)
86 if(req.algo_name() == "OpenPGP-S2K" && req.arg_count() == 1)
87 {
88 if(auto hash = HashFunction::create(req.arg(0)))
89 {
90 return std::unique_ptr<PasswordHashFamily>(new RFC4880_S2K_Family(hash.release()));
91 }
92 }
93 #endif
94
95 BOTAN_UNUSED(req);
96 BOTAN_UNUSED(provider);
97
98 return nullptr;
99 }
Botan::MessageAuthenticationCode::create
static std::unique_ptr< MessageAuthenticationCode > create(const std::string &algo_spec, const std::string &provider="")
Definition: mac.cpp:46
Botan::HashFunction::create
static std::unique_ptr< HashFunction > create(const std::string &algo_spec, const std::string &provider="")
Definition: hash.cpp:106
BOTAN_UNUSED
#define BOTAN_UNUSED(...)
Definition: assert.h:142
hash
MechanismType hash
Definition: p11_mechanism.cpp:64

std::unique_ptr< PasswordHashFamily > Botan::PasswordHashFamily::create_or_throw | ( | const std::string & | algo_spec,
|  | const std::string & | provider = `""`
| ) |  |
| static

Create an instance based on a name, or throw if the algo/provider combination cannot be found. If provider is empty then best available is chosen.

Definition at line 103 of file pwdhash.cpp.

References create().

105 {
106 if(auto pbkdf = PasswordHashFamily::create(algo, provider))
107 {
108 return pbkdf;
109 }
110 throw Lookup_Error("PasswordHashFamily", algo, provider);
111 }
Botan::PasswordHashFamily::create
static std::unique_ptr< PasswordHashFamily > create(const std::string &algo_spec, const std::string &provider="")
Definition: pwdhash.cpp:33

virtual std::unique_ptr<PasswordHash> Botan::PasswordHashFamily::default_params | ( |  | ) | const
| pure virtual

Return some default parameter set for this PBKDF that should be good enough for most users. The value returned may change over time as processing power and attacks improve.

Implemented in Botan::RFC4880_S2K_Family, Botan::PBKDF2_Family, Botan::Argon2_Family, Botan::Scrypt_Family, and Botan::Bcrypt_PBKDF_Family.

virtual std::unique_ptr<PasswordHash> Botan::PasswordHashFamily::from_iterations | ( | size_t | iterations | ) | const
| pure virtual

Return a parameter chosen based on a rough approximation with the specified iteration count. The exact value this returns for a particular algorithm may change from over time. Think of it as an alternative to tune, where time is expressed in terms of PBKDF2 iterations rather than milliseconds.

Implemented in Botan::RFC4880_S2K_Family, Botan::PBKDF2_Family, Botan::Argon2_Family, Botan::Scrypt_Family, and Botan::Bcrypt_PBKDF_Family.

virtual std::unique_ptr<PasswordHash> Botan::PasswordHashFamily::from_params | ( | size_t | i1,
|  | size_t | i2 = `0`,
|  | size_t | i3 = `0`
| ) |  | const
| pure virtual

Create a password hash using some scheme specific format. Eg PBKDF2 and PGP-S2K set iterations in i1 Scrypt uses N,r,p in i{1-3} Bcrypt-PBKDF just has iterations Argon2{i,d,id} would use iterations, memory, parallelism for i{1-3}, and Argon2 type is part of the family.

Values not needed should be set to 0

Implemented in Botan::RFC4880_S2K_Family, Botan::PBKDF2_Family, Botan::Argon2_Family, Botan::Scrypt_Family, and Botan::Bcrypt_PBKDF_Family.

virtual std::string Botan::PasswordHashFamily::name | ( |  | ) | const
| pure virtual

Returns
  name of this PasswordHash

Implemented in Botan::RFC4880_S2K_Family, Botan::PBKDF2_Family, Botan::Argon2_Family, Botan::Scrypt_Family, and Botan::Bcrypt_PBKDF_Family.

std::vector< std::string > Botan::PasswordHashFamily::providers | ( | const std::string & | algo_spec | ) |
| static

Returns
  list of available providers for this algorithm, empty if not available

Definition at line 113 of file pwdhash.cpp.

114 {
115 return probe_providers_of<PasswordHashFamily>(algo_spec, { "base", "openssl" });
116 }

virtual std::unique_ptr<PasswordHash> Botan::PasswordHashFamily::tune | ( | size_t | output_length,
|  | std::chrono::milliseconds | msec,
|  | size_t | max_memory_usage_mb = `0`
| ) |  | const
| pure virtual

Return a new parameter set tuned for this machine

Parameters

  output_length | how long the output length will be
  msec | the desired execution time in milliseconds
  max_memory_usage_mb | some password hash functions can use a tunable amount of memory, in this case max_memory_usage limits the amount of RAM the returned parameters will require, in mebibytes (2**20 bytes). It may require some small amount above the request. Set to zero to place no limit at all.

Implemented in Botan::RFC4880_S2K_Family, Botan::PBKDF2_Family, Botan::Argon2_Family, Botan::Scrypt_Family, and Botan::Bcrypt_PBKDF_Family.

The documentation for this class was generated from the following files:

- src/lib/pbkdf/pwdhash.h
- src/lib/pbkdf/pwdhash.cpp